aboutsummaryrefslogtreecommitdiff
path: root/net/mbusd/files
diff options
context:
space:
mode:
authorMarcin Jurkowski <marcin1j@gmail.com>2019-12-09 15:58:30 +0100
committerMarcin Jurkowski <marcin1j@gmail.com>2020-10-08 16:57:00 +0200
commit19794e9af859b07911a057abf920aa763eb302d1 (patch)
treeddaeb045909d9da8bc40113935a3d5ad5e11bdd8 /net/mbusd/files
parentd6689e7fad13d8c840c69fb64be995987d39c21f (diff)
mbusd: add mbusd
Mbusd is open-source Modbus TCP to Modbus RTU (RS-232/485) gateway. Signed-off-by: Marcin Jurkowski <marcin1j@gmail.com>
Diffstat (limited to 'net/mbusd/files')
-rw-r--r--net/mbusd/files/mbusd.conf17
-rw-r--r--net/mbusd/files/mbusd.init68
2 files changed, 85 insertions, 0 deletions
diff --git a/net/mbusd/files/mbusd.conf b/net/mbusd/files/mbusd.conf
new file mode 100644
index 000000000..ea4e2ed54
--- /dev/null
+++ b/net/mbusd/files/mbusd.conf
@@ -0,0 +1,17 @@
+config mbusd
+ option enabled 0
+ option port 502
+ option loglevel 2
+
+ #option max_connections 32
+ #option timeout 60
+
+ option device '/dev/ttyUSB0'
+ option speed 19200
+ option databits 8
+ option parity 0
+ option stopbits 2
+ option rts 0
+
+ #option rtu_retries 3
+ #option rtu_wait 500
diff --git a/net/mbusd/files/mbusd.init b/net/mbusd/files/mbusd.init
new file mode 100644
index 000000000..3699fbe1f
--- /dev/null
+++ b/net/mbusd/files/mbusd.init
@@ -0,0 +1,68 @@
+#!/bin/sh /etc/rc.common
+# Copyright (C) 2019 OpenWrt.org
+
+START=90
+USE_PROCD=1
+NAME=mbusd
+
+
+mbusd_instance() {
+ [ "$2" = 0 ] || {
+ echo "Validation failed"
+ return 1
+ }
+ [ "$enabled" -gt 0 ] || return 1
+
+
+ [ "$parity" = 0 ] && parity=n || parity=y
+ [ "$rts" = 0 ] && rts=
+
+
+ procd_open_instance mbusd-$port
+ procd_set_param command /usr/bin/mbusd \
+ -d \
+ -L - \
+ -P $port \
+ -v $loglevel \
+ ${max_connections:+-C $max_connections} \
+ ${timeout:+-T $timeout} \
+ -p $device \
+ -s $speed \
+ -m ${databits}${parity}${stopbits} \
+ ${rts:+-t} \
+ ${rtu_retries:+-N $rtu_retries} \
+ ${rtu_wait:+-W $rtu_wait}
+
+ procd_set_param stdout 1
+ procd_set_param stderr 1
+ procd_set_param respawn
+
+ procd_close_instance
+}
+
+validate_section_mbusd() {
+ uci_load_validate mbusd mbusd "$1" "$2" \
+ 'enabled:bool:1' \
+ 'port:port:502' \
+ 'loglevel:uinteger:2' \
+ 'max_connections:uinteger' \
+ 'timeout:uinteger' \
+ 'device:string' \
+ 'speed:uinteger' \
+ 'databits:uinteger' \
+ 'parity:bool' \
+ 'stopbits:uinteger' \
+ 'rts:bool:0' \
+ 'rtu_retries:uinteger' \
+ 'rtu_wait:uinteger'
+}
+
+start_service() {
+ config_load "$NAME"
+ config_foreach validate_section_mbusd mbusd mbusd_instance
+}
+
+service_triggers() {
+ procd_add_reload_trigger "$NAME"
+ procd_add_validation validate_section_mbusd
+}